#include <ctype.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include "item.h"
//#define ITEM "item.h"
//typedef FILE* stream;
static char* entrada;
static int pos;
static char buffer[MAX];

Item* Itemnovo (Chave chave){
  Item* pitem;
  if ((pitem = (Item*) malloc (sizeof(Item)))==NULL){
    printf ("Sem memoria para alocar ... fim!\n");
    exit (1);
  }
  else {
    pitem->chave = chave;
    pitem->contador = 1;
    return (pitem);
  }
  return (NULL);
}

void fgetstring (char *input, stream finput){
  long i =0;
  while (((*input = fgetc(finput)) != EOF) && (i < MAX)){
    input++;
    i++;
  }
  //   *input = '\0';
  input -= (int) i;
}

void getstring (char *input){
  long i =0;
  while (((*input= getchar()) != EOF)&& (i < MAX)) {
    input++;
    i++;
  }
  //   *input = '\0';
  input -= (int) i;
}

booleano Itemscan(void){
  //int cnt = 0;
  entrada = &(buffer[0]);
  getstring (entrada);
  if ((long) strlen(entrada) < MAX)
    return (false);
  else
    return (true);
}

booleano Itemfscan(stream finput){
  //int cnt = 0;
  entrada = &(buffer[0]);
  fgetstring (entrada, finput);
  if ((long) strlen(entrada) < MAX)
    return (false);
  else
    return (true);
}

void ItemsetInput (char* string){
  pos = 0;
  entrada = string;
}

void ItemsetPos (int local){
  pos = local;
}

void Itematribui (Item* item1, Item* item2){
  item1->contador = item2->contador;
  item1->chave = item2->chave;
}


booleano Itemget (Item **item){
  /* Deve fazer a gentileza de pegar NULL quando nao
     tiver mais palavras para pegar */
  char *string;
  if ((*item = (Item*) malloc (sizeof (Item))) == NULL){
    printf ("\nEstouro de memria\n");
    return (false);
  }
  else
    if (proxword ()){
      if ((string = getword())== NULL)
	return (false);
      else {
	(*item)->chave = string;
	(*item)->contador = 1;
      }
      return (true);
    }
    else return(false);
}

void fimpalavra (){
  int c;
  c = isalpha(entrada[pos]);
  while (c){
    c = isalpha(entrada[pos]);
    pos++;
  }
  pos--;
}
void strcopy (char *destino, char* origem, int pos_origem, int lenght_max){
  char *s=destino;
  int i; 
  origem += pos_origem;
  for (i=1; ((*s=*origem) != '\0')&&(i < lenght_max) ; ++s,++origem,++i)
    ;
  if (*s != '\0') {
    s++;
    *s='\0';
  }
}

char* getword (){
  int inicial,final;
  char *palavra;
  inicial = pos;
  fimpalavra ();
  final = pos;
  if (final > inicial){
    if ((palavra = (char*) malloc ((final-inicial)*sizeof(char)))==NULL){
      printf ("Nao consegui alocar string ...\n");
      palavra = NULL;
      exit(1);
    }
    strcopy (palavra,entrada, inicial, final-inicial);
  }
  else
    palavra = NULL;
  //pos = final;
  return (palavra);
}

booleano proxword (){
  while ((!isalpha(entrada[pos]))&&(pos < (int) strlen(entrada)))
    pos++;
  if (pos < (int) strlen(entrada))
    return (true);
  else
    return (false);
}

void Itemimprimir (Item *item){
  printf ("\n\t%s\t%d",item->chave, item->contador);
}
