#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#ifndef ITEM
#include "item.h"
#endif
#include "st.h"
// Poderia retornar Errorlevel
link STnovo_no (Item* item){
   link head;
   if ((head = (link) malloc (sizeof(tipo_no))) == NULL){
	printf ("Memoria insuficiente para alocar \n");
	exit(1);
   }
   else {
      head->item = item;
      head->esq = NULL;
      head->dir = NULL;
      return (head);
   }
   return (NULL);
}

link  STprocuraItem (link head, Chave chave){
   int valor;
   if (head == NULL) {
	return (NULL);
   }
   valor = compara(chave, head->item->chave);
   if ((valor) == 0)
	return (head);
   if ((valor) < 0)
	return (STprocuraItem (head->esq, chave));
   else
	return (STprocuraItem (head->dir, chave));
}
// void STinserirNO (link head, link no);
link STinserirItem (link head, Item* pitem){
   int valor;
   if (head==NULL)
	return (STnovo_no(pitem));
   valor = compara(pitem->chave, head->item->chave);
   if (valor == 0) {
	head->item->contador++;
	free (pitem->chave);
	free (pitem);
   }
   if (valor < 0)
      head->esq = STinserirItem (head->esq,pitem);
   else
      head->dir = STinserirItem (head->dir,pitem);
   return (head);
}
Item* STremoveItem (link head, Chave chave){
     Item* pitem;
     link temp = STremoveNO (head, chave);
     pitem = temp->item;
     free (temp);
     return (pitem);
}

link STremoveNO (link head, Chave chave) {
   link x;
   Chave chave2 = head->item->chave;
   int valor;
   if (head == NULL) {
	return (NULL);
   }
   valor = compara(chave2, head->item->chave);
   if ((valor) == 0) {
	//temp = head->item;
	x = head;
	head = joinLR (head->esq, head->dir);
	free (x);
   }
   if ((valor) < 0)
	head->esq = STremoveNO (head->esq, chave);
   else
	head->dir = STremoveNO (head->dir, chave);
   return (head);
}

//Item* STremoveMAX (link head);
//void STprocuraMAX (link head);

// rotinas baseados no livro Algorithms in C, Robert Sedgewick
link STinserirT (link h, Item* item){
   Chave chave = item->chave;
   int valor;
   if (h == NULL)
	return (STnovo_no(item));
   valor = compara (chave, h->item->chave);
   if (valor == 0) {
	h->item->contador++;
	free (chave);
   }
   if (valor < 0)
	h->esq = STinserirT (h->esq, item);
  else
	h->dir = STinserirT (h->dir, item);
  return (h);
}

link rotR (link h){
   link x = h->esq;
   h->esq = x->dir;
   x->dir = h;
   return (x);
}

link rotL (link h){

   link x = h->dir;
   h->dir = x->esq;
   x->esq = h;
   return (x);
}


link joinLR (link a, link b){
    if (b==NULL)
	return (a);
    b = partR(b,0);
    b->esq = a;
    return (b);
}

link partR (link head, int k){
   int valor = head->esq->N;
   if (valor > k){
     head->esq = partR(head->esq, k);
     head = rotR(head);
   }
   if (valor < k){
     head->dir = partR(head->dir, k - valor - 1);
     head = rotL(head);
   }
   return (head);
}

